# This is a machine-generated stub file for the NetBeans IDE Ruby Support.
#
# Many Ruby methods are "built in" which means that there is no
# Ruby source code for them. It is convenient for the IDE however to
# have these files for indexing and documentation purposes, so the following
# class definition is generated from the native implementation as a skeleton
# or stub to index.
#
# Ruby Version: "1.8.7-p72"
# Generator version: 1.0
#

#
#   
# A <code>Struct</code> is a convenient way to bundle a number of
# attributes together, using accessor methods, without having to write
# an explicit class.
#    
# The <code>Struct</code> class is a generator of specific classes,
# each one of which is defined to hold a set of variables and their
# accessors. In these examples, we'll call the generated class
# ``<i>Customer</i>Class,'' and we'll show an example instance of that
# class as ``<i>Customer</i>Inst.''
#    
# In the descriptions that follow, the parameter <i>symbol</i> refers
# to a symbol, which is either a quoted string or a
# <code>Symbol</code> (such as <code>:name</code>).
# 
class Struct
  include Enumerable
  #     struct == other_struct     => true or false
  #
  #
  # Equality---Returns <code>true</code> if <i>other_struct</i> is
  # equal to this one: they must be of the same class as generated by
  # <code>Struct::new</code>, and the values of all instance variables
  # must be equal (according to <code>Object#==</code>).
  #
  #    Customer = Struct.new(:name, :address, :zip)
  #    joe   = Customer.new("Joe Smith", "123 Maple, Anytown NC", 12345)
  #    joejr = Customer.new("Joe Smith", "123 Maple, Anytown NC", 12345)
  #    jane  = Customer.new("Jane Doe", "456 Elm, Anytown NC", 12345)
  #    joe == joejr   #=> true
  #    joe == jane    #=> false
  #
  #
  def ==
    # This is just a stub for a builtin Ruby method.
    # See the top of this file for more info.
  end

  #     struct[symbol] = obj    => obj
  #     struct[fixnum] = obj    => obj
  #
  #
  # Attribute Assignment---Assigns to the instance variable named by
  # <i>symbol</i> or <i>fixnum</i> the value <i>obj</i> and
  # returns it. Will raise a <code>NameError</code> if the named
  # variable does not exist, or an <code>IndexError</code> if the index
  # is out of range.
  #
  #    Customer = Struct.new(:name, :address, :zip)
  #    joe = Customer.new("Joe Smith", "123 Maple, Anytown NC", 12345)
  #
  #    joe["name"] = "Luke"
  #    joe[:zip]   = "90210"
  #
  #    joe.name   #=> "Luke"
  #    joe.zip    #=> "90210"
  #
  #
  def []=
    # This is just a stub for a builtin Ruby method.
    # See the top of this file for more info.
  end

  #     struct[symbol]    => anObject
  #     struct[fixnum]    => anObject
  #
  #
  # Attribute Reference---Returns the value of the instance variable
  # named by <i>symbol</i>, or indexed (0..length-1) by
  # <i>fixnum</i>. Will raise <code>NameError</code> if the named
  # variable does not exist, or <code>IndexError</code> if the index is
  # out of range.
  #
  #    Customer = Struct.new(:name, :address, :zip)
  #    joe = Customer.new("Joe Smith", "123 Maple, Anytown NC", 12345)
  #
  #    joe["name"]   #=> "Joe Smith"
  #    joe[:name]    #=> "Joe Smith"
  #    joe[0]        #=> "Joe Smith"
  #
  #
  def []
    # This is just a stub for a builtin Ruby method.
    # See the top of this file for more info.
  end

  #     struct.each {|obj| block }  => struct
  #
  #
  # Calls <i>block</i> once for each instance variable, passing the
  # value as a parameter.
  #
  #    Customer = Struct.new(:name, :address, :zip)
  #    joe = Customer.new("Joe Smith", "123 Maple, Anytown NC", 12345)
  #    joe.each {|x| puts(x) }
  #
  # <em>produces:</em>
  #
  #    Joe Smith
  #    123 Maple, Anytown NC
  #    12345
  #
  #
  def each
    # This is just a stub for a builtin Ruby method.
    # See the top of this file for more info.
  end

  #     struct.each_pair {|sym, obj| block }     => struct
  #
  #
  # Calls <i>block</i> once for each instance variable, passing the name
  # (as a symbol) and the value as parameters.
  #
  #    Customer = Struct.new(:name, :address, :zip)
  #    joe = Customer.new("Joe Smith", "123 Maple, Anytown NC", 12345)
  #    joe.each_pair {|name, value| puts("#{name} => #{value}") }
  #
  # <em>produces:</em>
  #
  #    name => Joe Smith
  #    address => 123 Maple, Anytown NC
  #    zip => 12345
  #
  #
  def each_pair
    # This is just a stub for a builtin Ruby method.
    # See the top of this file for more info.
  end

  #
  # code-seq:
  #  struct.eql?(other)   => true or false
  #
  # Two structures are equal if they are the same object, or if all their
  # fields are equal (using <code>eql?</code>).
  #
  #
  def eql?(p1)
    # This is just a stub for a builtin Ruby method.
    # See the top of this file for more info.
  end

  #     struct.hash   => fixnum
  #
  #
  # Return a hash value based on this struct's contents.
  #
  #
  def hash
    # This is just a stub for a builtin Ruby method.
    # See the top of this file for more info.
  end

  #     struct.to_s      => string
  #     struct.inspect   => string
  #
  #
  # Describe the contents of this struct in a string.
  #
  #
  def inspect
    # This is just a stub for a builtin Ruby method.
    # See the top of this file for more info.
  end

  #     struct.length    => fixnum
  #     struct.size      => fixnum
  #
  #
  # Returns the number of instance variables.
  #
  #    Customer = Struct.new(:name, :address, :zip)
  #    joe = Customer.new("Joe Smith", "123 Maple, Anytown NC", 12345)
  #    joe.length   #=> 3
  #
  #
  def length
    # This is just a stub for a builtin Ruby method.
    # See the top of this file for more info.
  end

  #     struct.members    => array
  #
  #
  # Returns an array of strings representing the names of the instance
  # variables.
  #
  #    Customer = Struct.new(:name, :address, :zip)
  #    joe = Customer.new("Joe Smith", "123 Maple, Anytown NC", 12345)
  #    joe.members   #=> ["name", "address", "zip"]
  #
  #
  def members
    # This is just a stub for a builtin Ruby method.
    # See the top of this file for more info.
  end

  #     Struct.new( [aString] [, aSym]+> )    => StructClass
  #     StructClass.new(arg, ...)             => obj
  #     StructClass[arg, ...]                 => obj
  #
  #
  # Creates a new class, named by <i>aString</i>, containing accessor
  # methods for the given symbols. If the name <i>aString</i> is
  # omitted, an anonymous structure class will be created. Otherwise,
  # the name of this struct will appear as a constant in class
  # <code>Struct</code>, so it must be unique for all
  # <code>Struct</code>s in the system and should start with a capital
  # letter. Assigning a structure class to a constant effectively gives
  # the class the name of the constant.
  #
  # <code>Struct::new</code> returns a new <code>Class</code> object,
  # which can then be used to create specific instances of the new
  # structure. The number of actual parameters must be
  # less than or equal to the number of attributes defined for this
  # class; unset parameters default to \nil{}.  Passing too many
  # parameters will raise an \E{ArgumentError}.
  #
  # The remaining methods listed in this section (class and instance)
  # are defined for this generated class.
  #
  #    # Create a structure with a name in Struct
  #    Struct.new("Customer", :name, :address)    #=> Struct::Customer
  #    Struct::Customer.new("Dave", "123 Main")   #=> #<Struct::Customer name="Dave", address="123 Main">
  #
  #    # Create a structure named by its constant
  #    Customer = Struct.new(:name, :address)     #=> Customer
  #    Customer.new("Dave", "123 Main")           #=> #<Customer name="Dave", address="123 Main">
  #
  #
  def self.new(arg)
    # This is just a stub for a builtin Ruby method.
    # See the top of this file for more info.
  end

  #     Struct.new( [aString] [, aSym]+> )    => StructClass
  #     StructClass.new(arg, ...)             => obj
  #     StructClass[arg, ...]                 => obj
  #
  #
  # Creates a new class, named by <i>aString</i>, containing accessor
  # methods for the given symbols. If the name <i>aString</i> is
  # omitted, an anonymous structure class will be created. Otherwise,
  # the name of this struct will appear as a constant in class
  # <code>Struct</code>, so it must be unique for all
  # <code>Struct</code>s in the system and should start with a capital
  # letter. Assigning a structure class to a constant effectively gives
  # the class the name of the constant.
  #
  # <code>Struct::new</code> returns a new <code>Class</code> object,
  # which can then be used to create specific instances of the new
  # structure. The number of actual parameters must be
  # less than or equal to the number of attributes defined for this
  # class; unset parameters default to \nil{}.  Passing too many
  # parameters will raise an \E{ArgumentError}.
  #
  # The remaining methods listed in this section (class and instance)
  # are defined for this generated class.
  #
  #    # Create a structure with a name in Struct
  #    Struct.new("Customer", :name, :address)    #=> Struct::Customer
  #    Struct::Customer.new("Dave", "123 Main")   #=> #<Struct::Customer name="Dave", address="123 Main">
  #
  #    # Create a structure named by its constant
  #    Customer = Struct.new(:name, :address)     #=> Customer
  #    Customer.new("Dave", "123 Main")           #=> #<Customer name="Dave", address="123 Main">
  #
  #
  def self.new(aString, aSym )
    # This is just a stub for a builtin Ruby method.
    # See the top of this file for more info.
  end

  #     struct.select {|i| block }    => array
  #
  #
  # Invokes the block passing in successive elements from
  # <i>struct</i>, returning an array containing those elements
  # for which the block returns a true value (equivalent to
  # <code>Enumerable#select</code>).
  #
  #    Lots = Struct.new(:a, :b, :c, :d, :e, :f)
  #    l = Lots.new(11, 22, 33, 44, 55, 66)
  #    l.select {|v| (v % 2).zero? }   #=> [22, 44, 66]
  #
  #
  def select
    # This is just a stub for a builtin Ruby method.
    # See the top of this file for more info.
  end

  #     struct.length    => fixnum
  #     struct.size      => fixnum
  #
  #
  # Returns the number of instance variables.
  #
  #    Customer = Struct.new(:name, :address, :zip)
  #    joe = Customer.new("Joe Smith", "123 Maple, Anytown NC", 12345)
  #    joe.length   #=> 3
  #
  #
  def size
    # This is just a stub for a builtin Ruby method.
    # See the top of this file for more info.
  end

  #     struct.to_a     => array
  #     struct.values   => array
  #
  #
  # Returns the values for this instance as an array.
  #
  #    Customer = Struct.new(:name, :address, :zip)
  #    joe = Customer.new("Joe Smith", "123 Maple, Anytown NC", 12345)
  #    joe.to_a[1]   #=> "123 Maple, Anytown NC"
  #
  #
  def to_a
    # This is just a stub for a builtin Ruby method.
    # See the top of this file for more info.
  end

  #     struct.to_s      => string
  #     struct.inspect   => string
  #
  #
  # Describe the contents of this struct in a string.
  #
  #
  def to_s
    # This is just a stub for a builtin Ruby method.
    # See the top of this file for more info.
  end

  #     struct.to_a     => array
  #     struct.values   => array
  #
  #
  # Returns the values for this instance as an array.
  #
  #    Customer = Struct.new(:name, :address, :zip)
  #    joe = Customer.new("Joe Smith", "123 Maple, Anytown NC", 12345)
  #    joe.to_a[1]   #=> "123 Maple, Anytown NC"
  #
  #
  def values
    # This is just a stub for a builtin Ruby method.
    # See the top of this file for more info.
  end

  #     struct.values_at(selector,... )  => an_array
  #
  #
  #  Returns an array containing the elements in
  #  _self_ corresponding to the given selector(s). The selectors
  #  may be either integer indices or ranges.
  #  See also </code>.select<code>.
  #
  #     a = %w{ a b c d e f }
  #     a.values_at(1, 3, 5)
  #     a.values_at(1, 3, 5, 7)
  #     a.values_at(-1, -3, -5, -7)
  #     a.values_at(1..3, 2...5)
  #
  #
  def values_at(selector)
    # This is just a stub for a builtin Ruby method.
    # See the top of this file for more info.
  end


end
